
             program vaplap
             implicit double precision(a-h,o-z)
       dimension s(40000),t(40000),r(40000),r1(40000),f(40000)
        dimension l(1000000),l2(1000000),l1(1000000)


ccc     initialization of the random generator
              ix=51477
                na=16807
                nmax=2147483647
       call cpu_time(t1)
ccc       size of the system
                n1=5000
ccc      number of MC simulations  at each step
                nt=5*n1
c                nt=1000000
ccc     number of sequential MC steps
                ne=30
ccc      radius of the jacobi method
                a=0.9d0
ccc       first step of the MC method

ccc      initialization of the score r(j) and the number of visits s(j)
                do j=1,n1
                s(j)=0
                r(j)=0
                enddo
ccc         Monte carlo loop
               do k=1,nt
ccc       stopping test of each loop : initialization
                test=0.d0
ccc     first equation picked at random
                 ix=abs(ix*na)
                ix=mod(ix,nmax)
                u1=dble(ix)/dble(nmax)
                i=dint(u1*n1)+1
ccc      initialization of the number of steps by walk
                i1=0
ccc     main loop
        do while((test.le.0.5d0))
ccc      increment number of visits
                s(i)=s(i)+1
                i1=i1+1
                 l(i1)=i
ccc    increment of the scores of visited states of a walk
                 do jj=1,i1
                 r(l(jj))=r(l(jj))+1
                 enddo
ccc     stopping test of jacobi
       nn=dint(dlog(nt*1.d0))+1
       do jjj=1,nn
                ix=abs(ix*na)
                ix=mod(ix,nmax)
                u1=dble(ix)/dble(nmax)
               if (u1.ge.a)   then
               test=1.d0
               else
                i=dint(2*u1*n1)+1
c                print*,i
               endif
               enddo
                enddo
                enddo
ccc      approximation of the solution r(j)
                 do j=1,n1
                 s(j)=max(1.d0,s(j))
                r(j)=r(j)/s(j)
                enddo
cc                print*,s(1),r(1)
ccc     error on the first two components of the vector
           print*,dabs(1.d0/(1-a)-r(1))

cccc     sequential monte carlo iterations
              do k1=1,ne
ccc         new right hanside
              do i=1,n1
              f(i)=0.d0
              do j=1,n1
              f(i)=f(i)+2.d0*a*r(j)/(2.d0*n1)
              enddo
              enddo
              
              do i=1,n1
              f(i)=f(i)-r(i)+1.d0
              enddo
ccc     computation of the residual
                do j=1,n1
                s(j)=0
                r1(j)=0
                enddo



               do k=1,nt
                test=0.d0
                 ix=abs(ix*na)
                ix=mod(ix,nmax)
                u1=dble(ix)/dble(nmax)
                i=dint(u1*n1)+1
                i1=0


         do while((test.le.0.5d0))
               ix=abs(ix*na)
                ix=mod(ix,nmax)
                u1=dble(ix)/dble(nmax)
                s(i)=s(i)+1
                i1=i1+1
                   l(i1)=i


                 do jj=1,i1
                 r1(l(jj))=r1(l(jj))+f(i)
                 enddo

                if (u1.ge.a)   then
               test=1.d0
                else
                do jjj=1,1
                i=dint(2*u1*n1)+1
                enddo
               endif

                enddo
                enddo
ccc          new approximation  r=r+r1
                 do j=1,n1
                  s(j)=max(1.d0,s(j))
                  r1(j)=r1(j)/s(j)
                  r1(j)=r1(j)+r(j)
                  r(j)=r1(j)
                 enddo
cc                 print*,s(1)
ccc           error on the first two components of the vector
                 print*,dabs(1.d0/(1-a)-r(2)),dabs(1.d0/(1-a)-r(1))
                enddo
             call cpu_time(t2)
             print*,t2-t1
               pause
            end
