c ceci est un commentaire
       program tp1 
c déclaration des variables en explicite
       implicit none 
       double precision x,x1,y,dx
       integer i,n
c autre alternative de déclaration en implicite
c       implicit double precision (a-h,o-z)  
       dimension x(1000),y(1000),x1(1000)
c fin des déclarations

       n = 100
       dx = 1.0d0/n
       do i=1,N+1
          x(i) = (i-1)*dx
          y(i) = x(i)-dexp(-x(i))
       enddo

       open(1,file='exp')
       do i=1,N+1
         write(1,*) x(i),y(i)
       enddo
       close(1)

       x1(1) = 0.5
       do i=2,8
          x1(i) = dexp(-x1(i-1))
          print*, x1(i)
       enddo

       end

c NOTE: quelques commandes bash (mode terminal)
c pour ouvrir directement un terminal dans le répertoire de travail, on peut utiliser le clic droit puis "ouvrir le terminal ici"
c ls : pour lister les fichiers du répertoire courant
c pwd : nom du répertoire courant 
c cd : répertoire courant (exple: cd tp1/)
c pour compiler un programme "fichier.f" et créer un executable "nom_executable.exe" : gfortran fichier.f -o nom_executable 
c on utilise la commande ./nom_executable pour exécuter le code "nom_executable"


c NOTE: quelques commandes pour GNUPLOT (mode terminal)
c gnuplot + entrée pour lancer le programme
c plot 'fichier_data' u 1:2 w l title 'nom de la fonction' permet de tracer les données contenues dans 
c le fichier 'fichier_data' en utilisant (u 1:2) la première colonne comme abscisse et la seconde 
c comme ordonnée avec la légende 'nom de la fonction'. w l signifie with line 

c Pour sauvegarde une image au format png
c set terminal png
c set output "nom_image.png"
c plot 'fichier_data' u 1:2 w l title 'nom de la fonction' 

c exit pour quitter gnuplot